/*****************************************************************************
 * Bison/Flexプログラム部分をテストするための、Windowsアプリケーションの雛型 *
 * □ビルド・実行方法:                                                       *
 * ┃"C:\Program Files (x86)\Microsoft Visual Studio\VC98\Bin\VCVARS32.BAT"  *
 * ┃make -f winapp.mk run                                                   *
 *****************************************************************************/
#include "winapp.h"
/*---------------------------------------------------------------------------*/
#define Label_Max	  50000		//ラベル登録最大数	//調整可
#define Inst_Max	1000000		//命令登録最大数	//調整可
typedef struct _ST_Inst {
	unsigned short	line;		//行番号		//1パス目で格納する。エラーメッセージのためだけに使用する。
	unsigned short	wait_cnt;	//ウェイト数		//1パス目で格納する。
	unsigned short	event_id;	//イベントID		//1パス目で格納する。
} ST_Inst;
static ST_Inst TBL_Inst[Inst_Max];	//命令配列
static int nInst;			//命令配列の格納数
static char* TBL_Label[Label_Max];	//ラベル配列
static int nLabel;			//ラベル配列の格納数
static int iRepeat = -1;		//ループ戻り位置の命令インデクス	defが現れたら無効値(-1)を格納する。repeatが現れたら命令インデクス(0～)をセットする。	ループ構造の構文エラーはy.tab.yで検出出来るので、winapp.cはiRepeatの正当性を確認しなくて良い。
					//					初期値を(-1)にしておかないと、main()から呼び出されたダミーのinst_end()がエラーになってしまう。
/****************************************************************************
 *	エラーログ用
 ****************************************************************************/
static char err_path[_MAX_PATH];	//'-e'オプションが指定されたら、エラーログファイル名を格納する。
static FILE* fp_err;			//最初のエラーログを記録する時に、エラーログファイルを作成する。
void yyerror(const char* fmt, ...) {	//←{{2015/03/06:'-e'オプション対応のためにwinapp.cから移動しました。}}
	//'-e'オプションが指定されていて、最初のエラーログを記録する時ならば…
	if(*err_path && !fp_err) {
		//エラーログファイルを作成する。
		fp_err = fopen(err_path, "w");
		if(!fp_err) { die("%s が作成できません。\n", err_path); }
		//エラーログファイルの出力ストリームは、バッファリング無しとする。
		// - die()で終了した時(abort()時)に、バッファ分がフラッシュされないようなので、こうしておく必要が有る。
		//   別の案として、この下の処理で毎回fflush()する方法も有るが、バッファリング無しとする方が簡単だろう。
		setbuf(fp_err, NULL);
	}
	//エラーメッセージ(,及び,エラーログ)を出力する。
	             fprintf(stderr, "### error at line %d : ", yylineno);	//エラーメッセージ
	if(fp_err) { fprintf(fp_err, "### error at line %d : ", yylineno); }	//エラーログ
	{
		va_list ap;
		va_start(ap, fmt);
		             vfprintf(stderr, fmt, ap);		//エラーメッセージ
		if(fp_err) { vfprintf(fp_err, fmt, ap); }	//エラーログ
		va_end(ap);
	}
	             fputc('\n', stderr);	//エラーメッセージ
	if(fp_err) { fputc('\n', fp_err); }	//エラーログ
}
/****************************************************************************
 *	ローカル関数宣言
 ****************************************************************************/
__declspec(noreturn) static void usage();
static ST_Inst* add_inst();
static void pass2(int bOptimize);
static void optimize();
static void output(char* sPrefix, char* sBinOut);
/****************************************************************************
 *	
 ****************************************************************************/
int main(int argc, char* argv[]) {
	int opt, bOptimize = 1;	//'-d'オプションが指定されなければ最適化を行う。
	char* sPrefix = "";	//'-p'オプションが指定されたらプレフィクス文字列を設定する。
	char* sBinOut = NULL;	//'-o'オプションが指定されたらバイナリ出力ファイル名を設定する。
#if     (YYDEBUG!=0)
//	yydebug = 1; //nonzero means print parse trace
#endif/*(YYDEBUG!=0)*/
	//コマンドラインオプションを処理する。
	opterr = 0; //オプションエラーは当プログラム内で処理するので、getopt()内でのエラー表示は不要。
	while((opt = getopt(argc, argv, "dp:o:eh")) != -1) {
		switch(opt) {
		case 'd':
			bOptimize = 0;		//最適化を行わない。
			break;
		case 'p':
			sPrefix = optarg;	//プレフィクス文字列を設定する。
			break;
		case 'o':
			sBinOut = optarg;	//バイナリ出力ファイル名を設定する。
			break;
		case 'e':
			{
				//エラーログファイル名を作成する。
				// - カレントフォルダに'実行ファイル名.err'という名前で生成する事にした。この動作は、'lk33.exe'の仕様を参考にした。
				char fname[_MAX_FNAME];
				_splitpath(argv[0], NULL, NULL, fname, NULL);
				_makepath(err_path, NULL, NULL, fname, ".err");
				//'-e'オプションが指定されたら、最初に確実に、既存のエラーログファイルを削除しておく。
				//前回に生成したエラーログが残っていて、今回生成したエラーログと混同する危険を避けるためである。
				//尚、'-e'オプションが指定されなかった場合は、既存のエラーログファイルを削除する処理は行わない。
				remove(err_path);
			}
			break;
		case 'h':
		default:
			usage();
		}
	}
	//ラベルを登録するためのハッシュテーブルを作成する。
	hcreate(Label_Max);
	//判り易さのために、命令位置0は使用しないことにした。命令位置0には、ダミーのend命令を置くことにした。
	inst_end();
	//--- 1パス目の処理 ---
	//ファイルが指定されていなければ、標準入力から読み込む。
	if(optind == argc) {
		yylex_init(stdin);
	    //{{2015/02/24修正:致命的なエラーが発生した場合(yyparse()!=0)のみ中断する。セマンティクスエラー(yynerrs!=0)だけならば全てのセマンティクスエラーを報告するために継続する。
	    //	if((yyparse() != 0) || (yynerrs != 0)) { die("エラーが発生しました。\n"); }
	    //↓2015/02/24修正:致命的なエラーが発生した場合(yyparse()!=0)のみ中断する。セマンティクスエラー(yynerrs!=0)だけならば全てのセマンティクスエラーを報告するために継続する。
		if((yyparse() != 0) /*|| (yynerrs != 0)*/) { die("エラーが発生しました。\n"); }
	    //}}2015/02/24修正:致命的なエラーが発生した場合(yyparse()!=0)のみ中断する。セマンティクスエラー(yynerrs!=0)だけならば全てのセマンティクスエラーを報告するために継続する。
	//ファイルが指定されていたら、各ファイルを読み込む。
	} else {
		int i;
		for(i = optind; i < argc; i++) {
			FILE* fp = fopen(argv[i], "r");
			if(!fp) { die("%s が開けません。\n", argv[i]); }
			yylex_init(fp);
		    //{{2015/02/24修正:致命的なエラーが発生した場合(yyparse()!=0)のみ中断する。セマンティクスエラー(yynerrs!=0)だけならば全てのセマンティクスエラーを報告するために継続する。
		    //	if((yyparse() != 0) || (yynerrs != 0)) { die("%s: エラーが発生しました。\n", argv[i]); }
		    //↓2015/02/24修正:致命的なエラーが発生した場合(yyparse()!=0)のみ中断する。セマンティクスエラー(yynerrs!=0)だけならば全てのセマンティクスエラーを報告するために継続する。
			if((yyparse() != 0) /*|| (yynerrs != 0)*/) { die("%s: エラーが発生しました。\n", argv[i]); }
		    //}}2015/02/24修正:致命的なエラーが発生した場合(yyparse()!=0)のみ中断する。セマンティクスエラー(yynerrs!=0)だけならば全てのセマンティクスエラーを報告するために継続する。
			fclose(fp);
		}
	}
	//1パス目の処理でエラーが発生しても、2パス目の処理を行って、全てのセマンティクスエラーを報告する。
	//--- 2パス目の処理 ---
	pass2(bOptimize);
	if(yynerrs != 0) { die("エラーが発生しました。\n"); }	//1パス目,又は,2パス目の処理でエラーが発生していたら、出力処理を行わない。
	//--- 出力処理 ---
	output(sPrefix, sBinOut);
	if(yynerrs != 0) { die("エラーが発生しました。\n"); }
	return EXIT_SUCCESS;
}
/*---------------------------------------------------------------------------*/
//使い方を表示して終了する。
__declspec(noreturn) static void usage() {
	fprintf(stderr, "dEvtTmrC - イベントタイマコンパイラ (%s)\n", VERSION);
	fprintf(stderr, "Copyright (C) 2015 Naoyuki Sawa\n");
	fprintf(stderr, "\n");
	fprintf(stderr, "USAGE:\n");
	fprintf(stderr, "  dEvtTmrC [option ...] [filename ...] \n");
	fprintf(stderr, "  ・filenameを指定しなければ、標準入力から読み込みます。\n");
	fprintf(stderr, "  ・filenameは、ワイルドカードによる複数指定も可能です。\n");
	fprintf(stderr, "\n");
	fprintf(stderr, "OPTIONS:\n");
	fprintf(stderr, "  -d           最適化を行いません。\n");
	fprintf(stderr, "               このオプションを指定しなければ、最適化を行います。\n");
	fprintf(stderr, "  -p文字列     ラベルに、プレフィクス文字列を追加します。\n");
	fprintf(stderr, "               このオプションを指定しなければ、プレフィクス文字列を追加しません。\n");
	fprintf(stderr, "  -oファイル名 イベント制御のバイナリデータを、バイナリ形式でファイルへ出力します。\n");
	fprintf(stderr, "               このオプションを指定しなければ、Cソース形式で標準出力へ出力します。\n");
	fprintf(stderr, "               このオプションの指定に関らず、ラベルは常に標準出力へ出力します。\n");
	fprintf(stderr, "  -e           エラーログファイルを生成します。\n");
	fprintf(stderr, "               このオプションを指定しても、エラーが発生しなければ生成されません。\n");
	fprintf(stderr, "  -h           使い方を表示します。\n");
	fprintf(stderr, "\n");
	fprintf(stderr, "EXAMPLE:\n");
	fprintf(stderr, "  ①dEvtTmrC.exe -pEvtTmrNo_ EvtTmr.txt > EvtTmr.c\n");
	fprintf(stderr, "  　EvtTmr.txtをコンパイルして、EvtTmr.cへ出力します。\n");
	fprintf(stderr, "  　ラベルのプレフィクス文字列として、EvtTmrNo_を追加します。\n");
	fprintf(stderr, "  ②dEvtTmrC.exe -pEvtTmrNo_ -oEvtTmr.bin EvtTmr.txt > EvtTmr.h\n");
	fprintf(stderr, "  　EvtTmr.txtをコンパイルして、ラベルをEvtTmr.hへ出力します。\n");
	fprintf(stderr, "  　イベント制御のバイナリデータを、EvtTmr.binへ出力します。\n");
	exit(EXIT_FAILURE);
}
/****************************************************************************
 *	1パス目の処理
 ****************************************************************************/
static ST_Inst* add_inst() {
	ST_Inst* pInst;
	if((unsigned)nInst >= Inst_Max) {
		yyerror("命令数が制限を超えました。(%d)", Inst_Max);
		exit(EXIT_FAILURE);
	}
	pInst = &TBL_Inst[nInst++];
	pInst->line = yylineno;		//行番号
	return pInst;
}
/*---------------------------------------------------------------------------*/
void inst_def(char* lab) {
	ENTRY item;
	item.key = (char*)lab;
	if(hsearch(item, FIND)) {
		yyerror("defのラベル定義が重複しています。(%s)", lab);
		yynerrs++;	//呼び出し元(main)に知らせるために。
		//全てのセマンティクスエラーを報告するために継続する。
	}
	item.data = (void*)nInst;
	if(!hsearch(item, ENTER)) {
		yyerror("ラベル数が制限を超えました。(%d)", Label_Max);
		yynerrs++;	//呼び出し元(main)に知らせるために。
		//全てのセマンティクスエラーを報告するために継続する。
	}
	if(nLabel < Label_Max) {
		TBL_Label[nLabel++] = lab;	//hsearch()はイテレーションの機能が無いので、後でイテレートするためにはキー配列を別に作成しておく必要が有る。
	}
	iRepeat = -1;		//ループ戻り位置の命令インデクスを無効にする。
}
/*---------------------------------------------------------------------------*/
void inst_repeat() {
	//waitの直後にrepeatが有る場合…(Sample/Sample.txtのSample4参照)
	ST_Inst* pInst;
	if((unsigned)nInst >= Inst_Max) {
		yyerror("命令数が制限を超えました。(%d)", Inst_Max);
		exit(EXIT_FAILURE);
	}
	pInst = &TBL_Inst[nInst];
	if(pInst->wait_cnt) {
		//repeatの直前のwaitはダミーの'event 0'にして、次の命令を生成しそれをrepeatの戻り先とする。
		//要するに、下記の【誤】の形になるのを避けて、【正】の形にするというわけです。
		//【誤】
		//		wait		10	←┐
		//	repeat				　│
		//		event		1	　│
		//		wait		20	　│
		//	end				─┘
		//【正】
		//		wait		10
		//		(event		0)
		//	repeat
		//		event		1	←┐	この下でadd_inst()する命令はこれに相当する。
		//		wait		20	　│
		//	end				─┘
		add_inst();
	}
	iRepeat = nInst;	//ループ戻り位置の命令インデクスを格納する。
}
/*---------------------------------------------------------------------------*/
void inst_end() {
	ST_Inst* pInst = add_inst();
	//ループ戻り位置の命令インデクスが無効ならば…	//def cmds end
	if(iRepeat == -1) {
		pInst->event_id = -1;		//end
	//ループ戻り位置の命令インデクスが有効ならば…	//def repeat cmds end,又は,def cmds repeat cmds end
	} else {
		//次の命令を基準として、ループ戻り位置の命令へのマイナス距離を求める。
		int dist = iRepeat - nInst;	//loop
		if((dist < SHRT_MIN) || (dist >= 0)) { DIE(); }	//距離が遠過ぎる,又は,バグ
		pInst->event_id = dist;
	}
	iRepeat = -1;		//ここで無効値(-1)を代入する事は必須ではない。endの次は(スクリプト終了でなければ)defが現れるはずでありdefで同じ処理を行うから。y.tab.yで検査されるのでwinapp.cが考慮する必要は無い。しかしデバッグし易さのためにここでも無効値(-1)を格納しておく事にした。
}
/*---------------------------------------------------------------------------*/
void inst_wait(int cnt) {
	ST_Inst* pInst;
	if((unsigned)nInst >= Inst_Max) {
		yyerror("命令数が制限を超えました。(%d)", Inst_Max);
		exit(EXIT_FAILURE);
	}
	pInst = &TBL_Inst[nInst];
    //{{2015/08/19変更:waitの引数に(2^16)以上の値も指定出来るようにしました。waitの引数に(2^16)以上の値を指定したり、複数のwaitの合計が(2^16)以上になったら、当ツールが自動的にダミーの'event 0'を含む複数の命令に展開します。
    //	if((unsigned)cnt > USHRT_MAX) {
    //		yyerror("waitの引数cntが範囲外です。(%d)", cnt);
    //		yynerrs++;	//呼び出し元(main)に知らせるために。
    //		//全てのセマンティクスエラーを報告するために継続する。
    //	} else if((unsigned)(pInst->wait_cnt + cnt) > USHRT_MAX) {
    //		yyerror("wait数が制限を超えました。(%d)", USHRT_MAX);
    //		yynerrs++;	//呼び出し元(main)に知らせるために。
    //		//全てのセマンティクスエラーを報告するために継続する。
    //	}
    //	pInst->wait_cnt += cnt;
    //↓2015/08/19変更:waitの引数に(2^16)以上の値も指定出来るようにしました。waitの引数に(2^16)以上の値を指定したり、複数のwaitの合計が(2^16)以上になったら、当ツールが自動的にダミーの'event 0'を含む複数の命令に展開します。
	if(cnt < 0) {
		yyerror("waitの引数cntが範囲外です。(%d)", cnt);
		yynerrs++;	//呼び出し元(main)に知らせるために。
		//全てのセマンティクスエラーを報告するために継続する。
	} else {
		//前のwait(有れば)と、今回のwaitの合計を求める。
		unsigned sum = pInst->wait_cnt + cnt;
		//waitの合計が((2^16)-1)超過ならば…
		while(sum > USHRT_MAX) {
			//waitが((2^16)-1)で'event 0'の、ダミー命令に分割する。
			pInst->wait_cnt = USHRT_MAX;
			add_inst();
			//次の命令のポインタを取得する。
			if((unsigned)nInst >= Inst_Max) {
				yyerror("命令数が制限を超えました。(%d)", Inst_Max);
				exit(EXIT_FAILURE);
			}
			pInst = &TBL_Inst[nInst];
			//waitの合計の残りを減らす。
			sum -= USHRT_MAX;
		}
		//waitの合計を((2^16)-1)に分割した余りを、次の命令に格納する。(0でも)
		//又は、waitの分割が発生しなかった場合は、元の命令に書き戻す。(0でも)
		pInst->wait_cnt = sum;
	}
    //}}2015/08/19変更:waitの引数に(2^16)以上の値も指定出来るようにしました。waitの引数に(2^16)以上の値を指定したり、複数のwaitの合計が(2^16)以上になったら、当ツールが自動的にダミーの'event 0'を含む複数の命令に展開します。
}
/*---------------------------------------------------------------------------*/
void inst_event(int id) {
	ST_Inst* pInst = add_inst();
	if((id < 1) || (id > SHRT_MAX)) {	//SHRT_MIN～(-2)=loop,(-1)=end,(0)=no_job,(1)～SHRT_MAX=event_id
		yyerror("eventの引数idが範囲外です。(%d)", id);
		yynerrs++;	//呼び出し元(main)に知らせるために。
		//全てのセマンティクスエラーを報告するために継続する。
	}
	pInst->event_id = id;	//event
}
/****************************************************************************
 *	2パス目の処理
 ****************************************************************************/
static void pass2(int bOptimize) {
	//2015/05/31現在、2パス目の処理は有りません。
	//今後、最適化機能を追加する場合のためのプレースホルダとして、関数のみ用意して有ります。
	//現在のところは、コマンドラインオプションに'-d'を指定してもしなくても違いは有りません。
	if(bOptimize) { optimize(); }
}
/*---------------------------------------------------------------------------*/
static void optimize() {
	//2015/05/31現在、最適化処理は有りません。
	//今後、最適化機能を追加する場合のためのプレースホルダとして、関数のみ用意して有ります。
	//現在のところは、コマンドラインオプションに'-d'を指定してもしなくても違いは有りません。
}
/****************************************************************************
 *	出力処理
 ****************************************************************************/
static int Label_compar(const void* x, const void* y) {
	return strcmp(*(char**)x, *(char**)y);
}
/*---------------------------------------------------------------------------*/
static void output(char* sPrefix, char* sBinOut) {
	int iLabel, iInst;
	ENTRY item, *pEntry;
	//ラベル定義を名前の昇順にソートする。
	qsort(TBL_Label, nLabel, sizeof(char*), Label_compar);
	//--- ラベルを標準出力に出力する ---
	for(iLabel = 0; iLabel < nLabel; iLabel++) {				//名前の昇順	ラベル=0(ダミー)は定義しない。
		char* label = TBL_Label[iLabel];
		printf("#define %s%s %d\n", sPrefix, label, iLabel + 1);	//ラベルは1ベース
	}
	if(*sPrefix) { printf("#define %sMax %d\n", sPrefix, nLabel); }		//プレフィクス文字列が有る場合のみ最大値を定義する。(プレフィクス文字列が無ければ定義しない。'Max'という単純なマクロ定義になり問題が有るから。)
	//--- データを出力する ---
	//バイナリ形式の場合…
	if(sBinOut) {
		FILE* fp = fopen(sBinOut, "wb");
		if(!fp) { die("%s が作成できません。\n", sBinOut); }
		//アドレステーブルを出力する。
		for(iLabel = -1; iLabel < nLabel; iLabel++) {
			int addr;
			if(iLabel < 0) {
				addr = nLabel + 1;				//TBL_EvtTmrNo[0]=(EvtTmrNo_Max+1)	ラベルは1ベースなのでnLabelではなく(nLabel+1)とする事に注意せよ。
			} else {
				char* label = TBL_Label[iLabel];
				item.key = label;
				if(!(pEntry = hsearch(item, FIND))) { DIE(); }	//バグ
				addr = (int)pEntry->data;
			}
			fwrite(&addr, sizeof(int), 1, fp);
		}
		//命令コードの出力を行う。
		for(iInst = 0; iInst < nInst; iInst++) {
			ST_Inst* pInst = &TBL_Inst[iInst];
			int wait_cnt = pInst->wait_cnt;
			int event_id = pInst->event_id;
			fwrite(&wait_cnt, sizeof(unsigned short), 1, fp);
			fwrite(&event_id, sizeof(unsigned short), 1, fp);
		}
		fclose(fp);
	//テキスト形式の場合…
	} else {
		//アドレステーブルを出力する。
		printf("const int TBL_EvtTmrNo[%d]={", nLabel + 1);
		for(iLabel = -1; iLabel < nLabel; iLabel++) {
			int addr;
			if(iLabel < 0) {
				addr = nLabel + 1;				//TBL_EvtTmrNo[0]=(EvtTmrNo_Max+1)	ラベルは1ベースなのでnLabelではなく(nLabel+1)とする事に注意せよ。
			} else {
				char* label = TBL_Label[iLabel];
				item.key = label;
				if(!(pEntry = hsearch(item, FIND))) { DIE(); }	//バグ
				addr = (int)pEntry->data;
			}
			if((iLabel & 15) == 15)    { putchar('\n'); }
			printf("0x%08X", addr);
			if(iLabel != (nLabel - 1)) { putchar(',' ); }
		}
		puts("};");
		//命令コードの出力を行う。
		printf("const unsigned short TBL_EvtTmr[%d][2]={", nInst);
		for(iInst = 0; iInst < nInst; iInst++) {
			ST_Inst* pInst = &TBL_Inst[iInst];
			int wait_cnt = pInst->wait_cnt;
			int event_id = pInst->event_id;
			if(  iInst      ) { putchar(',' ); }
			if(!(iInst & 15)) { putchar('\n'); }
			printf("{0x%04X,0x%04X}", wait_cnt, event_id);
		}
		puts("};");
	}
}
